local AddonName, Addon = ...

-- Options Frame
Addon.fOptions = CreateFrame("Frame", "IPMTSettings")
Addon.fOptions:SetSize(270, 180)
Addon.fOptions:SetPoint("CENTER", UIParent)
Addon.fOptions:SetBackdrop(Addon.backdrop)
Addon.fOptions:SetBackdropColor(0,0,0, 1)
Addon.fOptions:EnableMouse(true)
Addon.fOptions:RegisterForDrag("LeftButton")
Addon.fOptions:SetScript("OnDragStart", function(self, button)
    Addon:StartDragging(self, button)
end)
Addon.fOptions:SetScript("OnDragStop", function(self, button)
    Addon:StopDragging(self, button)
end)
Addon.fOptions:SetMovable(true)
Addon.fOptions:Hide()

-- Options caption
Addon.fOptions.caption = Addon.fOptions:CreateFontString(nil, "BACKGROUND", "GameFontHighlight")
Addon.fOptions.caption:SetPoint("CENTER", Addon.fOptions, "TOP", 0, -20)
Addon.fOptions.caption:SetJustifyH("CENTER")
Addon.fOptions.caption:SetSize(120, 20)
Addon.fOptions.caption:SetFont(Addon.FONT_ROBOTO, 20)
Addon.fOptions.caption:SetTextColor(1, 1, 1)
Addon.fOptions.caption:SetText(Addon.localization.OPTIONS)

-- Opactity slider
Addon.fOptions.opacity = CreateFrame("Slider", "IPMTOpacity", Addon.fOptions, "OptionsSliderTemplate")
Addon.fOptions.opacity:SetWidth(220)
Addon.fOptions.opacity:SetHeight(18)
Addon.fOptions.opacity:SetPoint("CENTER", Addon.fOptions, "TOP", 0, -66)
Addon.fOptions.opacity:SetOrientation('HORIZONTAL')
Addon.fOptions.opacity:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
Addon.fOptions.opacity:EnableMouseWheel(true)
Addon.fOptions.opacity:SetMinMaxValues(0, 100)
Addon.fOptions.opacity:SetValue(100)
Addon.fOptions.opacity:SetValueStep(1.0)
Addon.fOptions.opacity:SetObeyStepOnDrag(true)
getglobal(Addon.fOptions.opacity:GetName() .. 'Low'):SetText('0 %')
getglobal(Addon.fOptions.opacity:GetName() .. 'High'):SetText('100 %')
getglobal(Addon.fOptions.opacity:GetName() .. 'Text'):SetText(Addon.localization.OPACITY)
Addon.fOptions.opacity:SetScript('OnValueChanged', function(self)
    Addon:SetOpacity(self:GetValue())
end)
Addon.fOptions.opacity:SetScript('OnMouseWheel', function(self)
    Addon:SetOpacity(self:GetValue())
end)

-- Scale slider
Addon.fOptions.scale = CreateFrame("Slider", "IPMTScale", Addon.fOptions, "OptionsSliderTemplate")
Addon.fOptions.scale:SetWidth(220)
Addon.fOptions.scale:SetHeight(18)
Addon.fOptions.scale:SetPoint("CENTER", Addon.fOptions, "TOP", 0, -106)
Addon.fOptions.scale:SetOrientation('HORIZONTAL')
Addon.fOptions.scale:SetThumbTexture("Interface\\Buttons\\UI-SliderBar-Button-Horizontal")
Addon.fOptions.scale:EnableMouseWheel(true)
Addon.fOptions.scale:SetMinMaxValues(0, 100)
Addon.fOptions.scale:SetValue(0)
Addon.fOptions.scale:SetValueStep(1.0)
Addon.fOptions.scale:SetObeyStepOnDrag(true)
getglobal(Addon.fOptions.scale:GetName() .. 'Low'):SetText('100 %')
getglobal(Addon.fOptions.scale:GetName() .. 'High'):SetText('200 %')
getglobal(Addon.fOptions.scale:GetName() .. 'Text'):SetText(Addon.localization.SCALE)
Addon.fOptions.scale:SetScript('OnValueChanged', function(self)
    Addon:SetScale(self:GetValue())
end)
Addon.fOptions.scale:SetScript('OnMouseWheel', function(self)
    Addon:SetScale(self:GetValue())
end)

-- Close button
Addon.fOptions.close = CreateFrame("Button", nil, Addon.fOptions, "UIPanelButtonTemplate")
Addon.fOptions.close:SetPoint("CENTER", Addon.fOptions, "BOTTOM", 0, 30)
Addon.fOptions.close:SetSize(120, 30)
Addon.fOptions.close:SetText(Addon.localization.CLOSE)
Addon.fOptions.close:SetScript("OnClick", function(self)
    Addon.CloseOptions()
end)